SUBROUTINE cmatmul(dimen,V1,V2,MAT)
      !This subrotine calculates the matrix product
      !between two complex matrices V1,V2 of dimension: dimen x dimen
      ! The result is returned in MAT
      IMPLICIT NONE
      INTEGER,INTENT(IN) :: dimen
      COMPLEX*16,INTENT(OUT) :: MAT(dimen,dimen)
      COMPLEX*16,INTENT(IN)::V1(dimen,dimen),V2(dimen,dimen)
      DOUBLE PRECISION :: V1r(dimen,dimen),V2r(dimen,dimen),V1i(dimen,dimen),V2i(dimen,dimen)
      INTEGER :: i,j
      COMPLEX*16 :: im

      im = (0.0d0,1.0d0)
      
      DO i=1,dimen
        DO j=1,dimen
                V1r(i,j) = DBLE(V1(i,j))
                V2r(i,j) = DBLE(V2(i,j))
                V1i(i,j) = AIMAG(V1(i,j))
                V2i(i,j) = AIMAG(V2(i,j))
        ENDDO
      ENDDO
      MAT = MATMUL(V1r,V2r)-MATMUL(V1i,V2i)+im*( MATMUL(V1i,V2r)+MATMUL(V1r,V2i))
END SUBROUTINE cmatmul
      
